JUCE: juce::midi_ci::DeviceOptions Class Reference

JUCE

- Main Page
- Related Pages
- Topics
- Classes
- Files

- Class List
- Class Index
- Class Hierarchy
- Class Members

Loading...
Searching...
No Matches
Public Member Functions | Static Public Member Functions | Static Public Attributes | List of all members
juce::midi_ci::DeviceOptions Class Reference
juce_midi_ci » ci

Configuration options for a Device. More...

`#include <juce_CIDeviceOptions.h>`

## Public Member Functions
DeviceOptions | withOutputs (std::vector< DeviceMessageHandler * > x) const
| One or more DeviceMessageHandlers that should receive callbacks with any messages that the device wishes to send.
DeviceOptions | withFunctionBlock (FunctionBlock x) const
| The function block layout of this device.
DeviceOptions | withDeviceInfo (const ump::DeviceInfo &x) const
| Basic information about the device used to determine manufacturer, model, etc.
DeviceOptions | withFeatures (DeviceFeatures x) const
| The features that you want to enable on the device.
DeviceOptions | withMaxSysExSize (size_t x) const
| The maximum size of sysex messages to accept and to produce.
DeviceOptions | withProfileDelegate (ProfileDelegate *x) const
| Specifies a profile delegate that can be used to respond to particular profile events.
DeviceOptions | withPropertyDelegate (PropertyDelegate *x) const
| Specifies a property delegate that can be used to respond to particular property events.
DeviceOptions | withProductInstanceId (const std::array< char, 16 > &x) const
| Specifies a product instance ID that will be returned in endpoint response messages.
const auto & | getOutputs () const
const auto & | getFunctionBlock () const
const auto & | getDeviceInfo () const
const auto & | getFeatures () const
const auto & | getMaxSysExSize () const
const auto & | getProductInstanceId () const
const auto & | getProfileDelegate () const
const auto & | getPropertyDelegate () const

## Static Public Member Functions
static std::array< char, 16 > | makeProductInstanceId (Random &random)
| Creates a random product instance ID.

## Static Public Attributes
static constexpr auto | beginValidAscii = 32
static constexpr auto | endValidAscii = 127

## Detailed Description

Configuration options for a Device.

The options set here will remain constant over the lifetime of a Device.

## Member Function Documentation

## ◆ makeProductInstanceId()

static std::array< char, 16 > juce::midi_ci::DeviceOptions::makeProductInstanceId | ( | Random & | random | ) |
| static

Creates a random product instance ID.

This isn't really recommended - it's probably better to have a unique ID that remains persistent after a restart.

References beginValidAscii, endValidAscii, and Random::nextInt().

## ◆ withOutputs()

DeviceOptions juce::midi_ci::DeviceOptions::withOutputs | ( | std::vector< DeviceMessageHandler * > | x | ) | const

One or more DeviceMessageHandlers that should receive callbacks with any messages that the device wishes to send.

Referenced DeviceMessageHandlers must outlive any Device constructed from these options.

References withMember(), and x.

## ◆ withFunctionBlock()

DeviceOptions juce::midi_ci::DeviceOptions::withFunctionBlock | ( | FunctionBlock | x | ) | const

The function block layout of this device.

References withMember(), and x.

## ◆ withDeviceInfo()

DeviceOptions juce::midi_ci::DeviceOptions::withDeviceInfo | ( | const ump::DeviceInfo & | x | ) | const

Basic information about the device used to determine manufacturer, model, etc.

In order to populate this correctly, you'll need to register with the MIDI association - otherwise you might accidentally end up using IDs that are already assigned to other companies/individuals.

References withMember(), and x.

## ◆ withFeatures()

DeviceOptions juce::midi_ci::DeviceOptions::withFeatures | ( | DeviceFeatures | x | ) | const

The features that you want to enable on the device.

If you enable property exchange, you may wish to supply a PropertyDelegate using withPropertyDelegate(). If you enable profile configuration, you may wish to supply a ProfileDelegate using withProfileDelegate(). Process inquiry is not currently supported.

References withMember(), and x.

## ◆ withMaxSysExSize()

DeviceOptions juce::midi_ci::DeviceOptions::withMaxSysExSize | ( | size_t | x | ) | const

The maximum size of sysex messages to accept and to produce.

References withMember(), and x.

## ◆ withProfileDelegate()

DeviceOptions juce::midi_ci::DeviceOptions::withProfileDelegate | ( | ProfileDelegate * | x | ) | const

Specifies a profile delegate that can be used to respond to particular profile events.

The referenced ProfileDelegate must outlive the Device.

References withMember(), and x.

## ◆ withPropertyDelegate()

DeviceOptions juce::midi_ci::DeviceOptions::withPropertyDelegate | ( | PropertyDelegate * | x | ) | const

Specifies a property delegate that can be used to respond to particular property events.

The referenced PropertyDelegate must outlive the Device.

References withMember(), and x.

## ◆ withProductInstanceId()

DeviceOptions juce::midi_ci::DeviceOptions::withProductInstanceId | ( | const std::array< char, 16 > & | x | ) | const

Specifies a product instance ID that will be returned in endpoint response messages.

References jassertfalse, withMember(), and x.

## ◆ getOutputs()

const auto & juce::midi_ci::DeviceOptions::getOutputs | ( |  | ) | const

See also
  withOutputs()

## ◆ getFunctionBlock()

const auto & juce::midi_ci::DeviceOptions::getFunctionBlock | ( |  | ) | const

See also
  withFunctionBlock()

## ◆ getDeviceInfo()

const auto & juce::midi_ci::DeviceOptions::getDeviceInfo | ( |  | ) | const

See also
  withDeviceInfo()

## ◆ getFeatures()

const auto & juce::midi_ci::DeviceOptions::getFeatures | ( |  | ) | const

See also
  withFeatures()

## ◆ getMaxSysExSize()

const auto & juce::midi_ci::DeviceOptions::getMaxSysExSize | ( |  | ) | const

See also
  withMaxSysExSize()

## ◆ getProductInstanceId()

const auto & juce::midi_ci::DeviceOptions::getProductInstanceId | ( |  | ) | const

See also
  withProductInstanceId()

## ◆ getProfileDelegate()

const auto & juce::midi_ci::DeviceOptions::getProfileDelegate | ( |  | ) | const

See also
  withProfileDelegate()

## ◆ getPropertyDelegate()

const auto & juce::midi_ci::DeviceOptions::getPropertyDelegate | ( |  | ) | const

See also
  withPropertyDelegate()

## Member Data Documentation

## ◆ beginValidAscii

constexpr auto juce::midi_ci::DeviceOptions::beginValidAscii = 32
| staticconstexpr

Referenced by makeProductInstanceId().

## ◆ endValidAscii

constexpr auto juce::midi_ci::DeviceOptions::endValidAscii = 127
| staticconstexpr

Referenced by makeProductInstanceId().

The documentation for this class was generated from the following file:

- juce_CIDeviceOptions.h